<?php namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Denominations;
use App\Order;
use App\Helper\PDFHelper;
use App\Helper\ResponseHelper;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use DB;

class Script extends Command {

    /**
     * The console command name.
     *
     * @var string
     */
    protected $name = 'my:command';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Run my command.';

    /**
     * Execute the console command.
     *
     * @return void
     */
    public function fire() {
        DB::connection()->disableQueryLog();    
        if (Order::where('status', 'generating')->exists()) {
            return;
        }
        $order = Order::where('status', 'authorized')->first();
        if (!isset($order)) {
            return;
        }
        $order->status='generating';
        $order->save();
        $pdfHelper = new PDFHelper(json_decode($order->json));
        return $pdfHelper->handle($order);
    }


}
