<?php

namespace App\Helper;

use SimpleSoftwareIO\QrCode\Facades\QrCode;
use Milon\Barcode\DNS1D;
	
class CodeHelper {

	private static $qrs;
	private static $barcodes;

	public static function generateQr($values) {
		self::$qrs = array();
		foreach ($values as $value) {
			$qr = QrCode::encoding('UTF-8')->generate($value);
			$xml = simplexml_load_string($qr);
			$defs = $xml->defs;
			if (!isset($defs->rect)) {
				$rect = $defs->addChild('rect');
				$rect->addAttribute('id', 'r0');
				$rect->addAttribute('width', '1');
				$rect->addAttribute('height', '1');
				$rect->addAttribute('fill', '#000000');
				$qr = $xml->asXML();
			}
			self::$qrs[] = '@' . $qr;
		}
		return self::$qrs;
	}

	public static function generateBarcode($values) {
		self::$barcodes = array();
		foreach ($values as $value) {
			$barcode = DNS1D::getBarcodeSVG($value, "C128");
			self::$barcodes[] = '@'.$barcode;
		}
		return self::$barcodes;
	}
}