<?php

namespace App\Helper;

use Illuminate\Support\Facades\Storage;

class S3Helper {

	private $storage;
	private static $s3helper;

	private function __construct() {
		$this->storage = Storage::disk('s3');
	}

	public static function get() {
		if (!isset(self::$s3helper)){
			self::$s3helper = new S3Helper();
		}
		return self::$s3helper;
	}

	public function save($pdf, $pdfmodel) {
		$uniqname = uniqid().'.pdf';
		$pdfmodel->url = $uniqname;
		$this->storage->put("pdfs/{$uniqname}", $pdf->Output('', 'S')); //Production
		//Storage::put("pdfs/{$uniqname}", $pdf->Output('', 'S')); //Test
		return $uniqname;
	}

}
