<?php

namespace App\Helper;

use App\UUID;
use App\Helper\FirebaseHelper;
use DB;

class UUIDHelper {

	/*
	 * @deprecated Servía para sólo utilizar 12 dígitos en lugar de los 32 del UUID
	 */ 
	public static function getUnique($length=12) {
		// start with a blank password
		$vCode = "";
		// define possible characters
		$possible = "0123456789ABCDEFGHIJKMNOPQRSTUVWXYZ";
		// set up a counter
		$i = 0;
		// add random characters to $password until $length is reached
		while ($i < $length) {
			// pick a random character from the possible ones
			$char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
			// we don't want this character if it's already in the password
			$vCode .= $char;
			$i++;
		}  // done!
		return $vCode;
    }

    public static function v4() {
    	return sprintf('%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
			mt_rand(0, 0xffff), 
			mt_rand(0, 0xffff),
			mt_rand(0, 0xffff),
			mt_rand(0, 0x0fff) | 0x4000,
			mt_rand(0, 0x3fff) | 0x8000,
			mt_rand(0, 0xffff), 
			mt_rand(0, 0xffff), 
			mt_rand(0, 0xffff)
    	);
  	}

    public static function getUUIDs($quantity, $folios, $idpdf) {
    	$uuids = array();
    	$tmp = '';
    	for ($i=0; $i<$quantity; $i++) {
    		do {
	    		$tmp = self::v4();
	    	} while(UUID::where('uuid', $tmp)->exists());
	    	FirebaseHelper::get()->addVale($tmp);
	    	/*$uuid = new UUID();
	    	$uuid->uuid = $tmp;
	    	$uuid->status = 'disabled';
	    	$uuid->folio = $folios[$i];
	    	$uuid->save();*/
		DB::connection('mysql')->disableQueryLog();    
			DB::table('ws_uuids')->insert([
				'uuid' => $tmp, 
				'status' => 'disabled',
				'folio' => $folios[$i],
				'id_pdf' => $idpdf
			]);
    		$uuids[] = $tmp;
    	}
    	return $uuids;
    }

    public static function separate($uuid) {
    	$separatedUUID = "";
    	for ($i=0; $i<strlen($uuid); $i++) {
    		$separatedUUID.=$uuid{$i}." ";
    	}
    	return $separatedUUID;
    }
}
