<?php
require_once('TCPDF/tcpdf.php');
require_once('FPDI/fpdi.php');
/**
 * @todo
 * Usa TCPDF y FPDI
 * Funcionalidad para Rotar Textos y Imagenes
 * @author @JotaOwen
*/
class PDF_Rotate extends FPDI {
    var $angle=0;

    function Rotate($angle,$x=-1,$y=-1){
        if($x==-1)
            $x=$this->x;
        if($y==-1)
            $y=$this->y;
        if($this->angle!=0)
            $this->_out('Q');
        $this->angle=$angle;
        if($angle!=0)
        {
            $angle*=M_PI/180;
            $c=cos($angle);
            $s=sin($angle);
            $cx=$x*$this->k;
            $cy=($this->h-$y)*$this->k;
            $this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
        }
    }

    function _endpage(){
        if($this->angle!=0)
        {
            $this->angle=0;
            $this->_out('Q');
        }
        parent::_endpage();
    }

}/*END CLASS*/


class PDF_OLD extends PDF_Rotate {

    function RotatedText($x,$y,$txt,$angle){
        //Text rotated around its origin
        $this->Rotate($angle,$x,$y);
        $this->Text($x,$y,$txt);
        $this->Rotate(0);
    }

    function RotatedImage($file,$x,$y,$w,$h,$angle){
        //Image rotated around its upper-left corner
        $this->Rotate($angle,$x,$y);
        $this->Image($file,$x,$y,$w,$h);
        $this->Rotate(0);
    }

}/*END CLASS*/


class PDF extends PDF_Rotate {
    /**
     * "Remembers" the template id of the imported page
     */
    var $_tplIdx;

    /**
     * Draw an imported PDF logo on every page
     */
    function Header() {
        if (is_null($this->_tplIdx)) {
            //$this->setSourceFile("logo.pdf");
            //$this->_tplIdx = $this->importPage(1);
        }
        // $size = $this->useTemplate($this->_tplIdx, 130, 5, 60);

        // $this->SetFont('freesans', 'B', 20);
        // $this->SetTextColor(0);
        // $this->SetXY(PDF_MARGIN_LEFT, 5);
        // $this->Cell(0, $size['h'], 'TCPDF and FPDI');
    }

    function Footer() {
        // emtpy method body
    }
}
